<?php
/*
// ===========================================================================
// HTML Header {header.php}
// ===========================================================================
*/

require_once('include/common.php');
require_once('include/style.php');

// ---------------------------------------------------------------------------
// HEAD
// ---------------------------------------------------------------------------

echo "<html>\n<head>\n\n\t<title>${Config['Title']}" . (@$title ? " - $title" : '') . "</title>\n";

if (isset($Lang['Charset'])) 
{
	echo "\t<meta http-equiv=\"Content-Type\" content=\"text/html; charset=${Lang['Charset']}\">\n";
	echo "\t<meta charset=\"${Lang['Charset']}\">\n";
}

if (@$Config['Refresh']) echo "\t<meta http-equiv=\"refresh\" content=\"${Config['Refresh']}; url=${_SERVER['PHP_SELF']}\">\n";
if (@$Config['Cache']) echo "\t<meta name=\"pragma\" content=\"${Config['Cache']}\">\n";
if (@$Config['Author']) echo "\t<meta name=\"author\" content=\"${Config['Author']}\">\n";
if (@$Config['Description']) echo "\t<meta name=\"description\" content=\"${Config['Description']}\">\n";
if (@$Config['Generator']) echo "\t<meta name=\"generator\" content=\"${Config['Generator']}\">\n";
if (@$Config['Keywords']) echo "\t<meta name=\"keywords\" content=\"${Config['Keywords']}\">\n";

if (isset($Meta) && is_array($Meta)) echo "\t" . join("\n\t", $Meta) . "\n";

if (!isset($Styles)) $Styles = array();

if (isset($Config['Stylesheet'])) array_unshift($Styles, $Config['Stylesheet']);
if (isset($Style['Stylesheet'])) array_unshift($Styles, $Style['Stylesheet']);

if (is_array($Styles)) {
	foreach ($Styles as $css) {
		if (empty($css) || !file_exists($ROOT . $css)) continue;
		echo "\t<link rel=\"stylesheet\" type=\"text/css\" href=\"$ROOT$css\" />\n";
	}
}

if (@$Config['ShortcutIcon']) echo "\t<link rel=\"shortcut icon\" href=\"${Config['ShortcutIcon']}\" />\n";

// ---------------------------------------------------------------------------
// CUSTOM STUFF
// ---------------------------------------------------------------------------

?>	<link rel="alternate" type="application/rss+xml" title="Chatlog" href="<?php echo @$Config["URL"]; ?>rss/chat" />
	<link rel="alternate" type="application/rss+xml" title="News" href="<?php echo @$Config["URL"]; ?>rss/news" />
<?php

// ---------------------------------------------------------------------------
// SCRIPTS
// ---------------------------------------------------------------------------

if (!empty($Script)) {
	$Script=is_array($Script)?array_unique($Script):array($Script);
	for ($i = 0; $i < count($Script); $i++) {
		if (strpos($Script[$i], '://') !== false) $src = $Script[$i];
		else {
			$src = 'js/' . htmlspecialchars($Script[$i]);
			if (substr($src, -3) != '.js') $src .= '.js';
			if (!file_exists(getcwd() . '/' . $src)) continue;
		}
		echo "\t<script language=\"javascript\" src=\"$src\"></script>\n";
	}
}

// ---------------------------------------------------------------------------
// HEAD
// ---------------------------------------------------------------------------

if (isset($Head) && is_array($Head))
{
	foreach ($Head as $e) {
		if (!$e=trim($e)) continue;
		echo "\n$e\n";
	}
}

?>

</head>
<?php

// ---------------------------------------------------------------------------
// BODY
// ---------------------------------------------------------------------------

// TODO: Check if not better to just use simple template (twig like) for that

?>

<body>

<?php

// TODO: Horror

if (@!$Style['Client'])
{
	locale('website/menu');

	include(STYLE.'header.php');
}
