DROP TABLE `galaxy`.`galaxy_hero` ;

CREATE TABLE `galaxy`.`galaxy_hero` (
  `key` INT NOT NULL AUTO_INCREMENT,
  `create` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update` TIMESTAMP NULL DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP,
  `owner` INT NULL,
  `name` VARCHAR(50) NULL,
  `gender` ENUM ('', 'M', 'F') NOT NULL DEFAULT '',
  `age` INT NULL,
  `level` INT NULL,
  `location` VARCHAR(50) NULL,
  `area` VARCHAR(50) NULL,
  `x` FLOAT NULL,
  `y` FLOAT NULL,
  `z` FLOAT NULL,
  `action` ENUM ('' , 'MOVE', 'USE', 'DROP', 'TAKE') NOT NULL DEFAULT '',
  `target` INT NULL,
  `card` MEDIUMTEXT NULL,
  PRIMARY KEY (`key`),
  KEY (`owner`),
  KEY (`area`),
  KEY (`name`)
);

INSERT INTO `galaxy`.`galaxy_hero` (`name`) VALUES ('Han Solo');

SELECT * FROM `galaxy`.`galaxy_hero`;

DO SLEEP(1);

UPDATE `galaxy`.`galaxy_hero` SET `age` = 56 WHERE `name` = 'Han Solo';

SELECT * FROM `galaxy`.`galaxy_hero`;
